.text
.globl min
min:
  # Allouer de l'espace en haut de la pile
  addiu $sp, $sp, -8

  # Recuperer les parametres
  move $t0, $4        # t0 = i
  move $t1, $5        # t1 = j

  # Sauvegarder les parametres dans la pile
  sw $t0, 0($sp)
  sw $t1, 4($sp)
  
  # Effectuer l'operation min(i, j)
  move $t2, $t0
  slt $t3, $t0, $t1
  movz $t2, $t1, $t3

  # Placer la valeur de retour dans le registre correspondant
  move $2, $t2

  # Restaurer la pile
  addiu $sp, $sp, 8

  # Retourner de la fonction min(i, j)
  jr $ra


.globl main
main:
  # Decaler sp pour remplir la pile ensuite
  addiu $sp, $sp, -16

  # Sauvegarder ra
  sw $ra, 12($sp)

  # Allouer et initialiser i
  li $t0, 2             # i = 2
  sw $t0, 8($sp)        # Sauvegarder i dans la pile

  # Allouer et initialiser j
  li $t1, 5             # j = 5
  sw $t1, 4($sp)        # Sauvegarder j dans la pile

  # Appeler min(i, j): 
  #   1) Recuperer les valeurs dans les registres pour le passage des arguments i et j
  lw $4, 8($sp)         # $a0 = i
  lw $5, 4($sp)         # $a1 = j
  #   2) Appeler min(i, j)
  jal min
  #   3) Recuperer la valeur de retour de min(i, j) et l'enregistrer dans la pile
  move $t2, $2
  sw $t2, 0($sp)

  # Restaurer l'etat des registres utiles et de la pile
  lw $ra, 12($sp)
  addiu $sp, $sp, 16

  # Retourner de la fonction main()
  jr $ra
